<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ClientCnxnSocket.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">ClientCnxnSocket.java</span></div><h1>ClientCnxnSocket.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.SocketAddress;
import java.nio.ByteBuffer;
import java.util.LinkedList;
import java.util.List;

import org.apache.jute.BinaryInputArchive;
import org.apache.zookeeper.ClientCnxn.Packet;
import org.apache.zookeeper.proto.ConnectResponse;
import org.apache.zookeeper.server.ByteBufferInputStream;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * A ClientCnxnSocket does the lower level communication with a socket
 * implementation.
 * 
 * This code has been moved out of ClientCnxn so that a Netty implementation can
 * be provided as an alternative to the NIO socket code.
 * 
 */
<span class="fc" id="L43">abstract class ClientCnxnSocket {</span>
<span class="fc" id="L44">    private static final Logger LOG = LoggerFactory.getLogger(ClientCnxnSocket.class);</span>

    protected boolean initialized;

    /**
     * This buffer is only used to read the length of the incoming message.
     */
<span class="fc" id="L51">    protected final ByteBuffer lenBuffer = ByteBuffer.allocateDirect(4);</span>

    /**
     * After the length is read, a new incomingBuffer is allocated in
     * readLength() to receive the full message.
     */
<span class="fc" id="L57">    protected ByteBuffer incomingBuffer = lenBuffer;</span>
<span class="fc" id="L58">    protected long sentCount = 0;</span>
<span class="fc" id="L59">    protected long recvCount = 0;</span>
    protected long lastHeard;
    protected long lastSend;
    protected long now;
    protected ClientCnxn.SendThread sendThread;

    /**
     * The sessionId is only available here for Log and Exception messages.
     * Otherwise the socket doesn't need to know it.
     */
    protected long sessionId;

    void introduce(ClientCnxn.SendThread sendThread, long sessionId) {
<span class="fc" id="L72">        this.sendThread = sendThread;</span>
<span class="fc" id="L73">        this.sessionId = sessionId;</span>
<span class="fc" id="L74">    }</span>

    void updateNow() {
<span class="fc" id="L77">        now = System.currentTimeMillis();</span>
<span class="fc" id="L78">    }</span>

    int getIdleRecv() {
<span class="fc" id="L81">        return (int) (now - lastHeard);</span>
    }

    int getIdleSend() {
<span class="fc" id="L85">        return (int) (now - lastSend);</span>
    }

    long getSentCount() {
<span class="fc" id="L89">        return sentCount;</span>
    }

    long getRecvCount() {
<span class="fc" id="L93">        return recvCount;</span>
    }

    void updateLastHeard() {
<span class="fc" id="L97">        this.lastHeard = now;</span>
<span class="fc" id="L98">    }</span>

    void updateLastSend() {
<span class="fc" id="L101">        this.lastSend = now;</span>
<span class="fc" id="L102">    }</span>

    void updateLastSendAndHeard() {
<span class="fc" id="L105">        this.lastSend = now;</span>
<span class="fc" id="L106">        this.lastHeard = now;</span>
<span class="fc" id="L107">    }</span>

    protected void readLength() throws IOException {
<span class="fc" id="L110">        int len = incomingBuffer.getInt();</span>
<span class="pc bpc" id="L111" title="2 of 4 branches missed.">        if (len &lt; 0 || len &gt;= ClientCnxn.packetLen) {</span>
<span class="nc" id="L112">            throw new IOException(&quot;Packet len&quot; + len + &quot; is out of range!&quot;);</span>
        }
<span class="fc" id="L114">        incomingBuffer = ByteBuffer.allocate(len);</span>
<span class="fc" id="L115">    }</span>

    void readConnectResult() throws IOException {
<span class="pc bpc" id="L118" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L119">            StringBuilder buf = new StringBuilder(&quot;0x[&quot;);</span>
<span class="nc bnc" id="L120" title="All 2 branches missed.">            for (byte b : incomingBuffer.array()) {</span>
<span class="nc" id="L121">                buf.append(Integer.toHexString(b) + &quot;,&quot;);</span>
            }
<span class="nc" id="L123">            buf.append(&quot;]&quot;);</span>
<span class="nc" id="L124">            LOG.trace(&quot;readConnectResult &quot; + incomingBuffer.remaining() + &quot; &quot;</span>
<span class="nc" id="L125">                    + buf.toString());</span>
        }
<span class="fc" id="L127">        ByteBufferInputStream bbis = new ByteBufferInputStream(incomingBuffer);</span>
<span class="fc" id="L128">        BinaryInputArchive bbia = BinaryInputArchive.getArchive(bbis);</span>
<span class="fc" id="L129">        ConnectResponse conRsp = new ConnectResponse();</span>
<span class="fc" id="L130">        conRsp.deserialize(bbia, &quot;connect&quot;);</span>

        // read &quot;is read-only&quot; flag
<span class="fc" id="L133">        boolean isRO = false;</span>
        try {
<span class="fc" id="L135">            isRO = bbia.readBool(&quot;readOnly&quot;);</span>
<span class="nc" id="L136">        } catch (IOException e) {</span>
            // this is ok -- just a packet from an old server which
            // doesn't contain readOnly field
<span class="nc" id="L139">            LOG.warn(&quot;Connected to an old server; r-o mode will be unavailable&quot;);</span>
<span class="fc" id="L140">        }</span>

<span class="fc" id="L142">        this.sessionId = conRsp.getSessionId();</span>
<span class="fc" id="L143">        sendThread.onConnected(conRsp.getTimeOut(), this.sessionId,</span>
<span class="fc" id="L144">                conRsp.getPasswd(), isRO);</span>
<span class="fc" id="L145">    }</span>

    abstract boolean isConnected();

    abstract void connect(InetSocketAddress addr) throws IOException;

    abstract SocketAddress getRemoteSocketAddress();

    abstract SocketAddress getLocalSocketAddress();

    abstract void cleanup();

    abstract void close();

    abstract void wakeupCnxn();

    abstract void enableWrite();

    abstract void disableWrite();

    abstract void enableReadWriteOnly();

    abstract void doTransport(int waitTimeOut, List&lt;Packet&gt; pendingQueue,
            LinkedList&lt;Packet&gt; outgoingQueue, ClientCnxn cnxn)
            throws IOException, InterruptedException;

    abstract void testableCloseSocket() throws IOException;

    abstract void sendPacket(Packet p) throws IOException;
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>